package Ex1;

// Exercise 10.8 Solution: PayrollSystemTest.java
// Employee hierarchy test program.
import java.util.Scanner; // program uses Scanner to obtain user input

public class PayrollSystemTest 
{
   public static void main( String[] args ) 
   {
      // create subclass objects
      SalariedEmployee salariedEmployee = 
         new SalariedEmployee( 
         "John", "Smith", "111-11-1111", 6, 15, 1944, 800.00 );
      HourlyEmployee hourlyEmployee = 
         new HourlyEmployee( 
         "Karen", "Price", "222-22-2222", 12, 29, 1960, 16.75, 40 );
      CommissionEmployee commissionEmployee = 
         new CommissionEmployee( 
         "Sue", "Jones", "333-33-3333", 9, 8, 1954, 10000, .06 );
      BasePlusCommissionEmployee basePlusCommissionEmployee = 
         new BasePlusCommissionEmployee( 
         "Bob", "Lewis", "444-44-4444", 3, 2, 1965, 5000, .04, 300 );

      PieceWorker pieceWorker = 
           new PieceWorker("James", "Belushi", "111-44-1111", 
              3, 2, 1960, 50.5, 100);
      
      
      System.out.println( "Employees processed individually:\n" );
      
      System.out.printf( "%s\n%s: $%,.2f\n\n", 
         salariedEmployee, "earned", salariedEmployee.earnings() );
      System.out.printf( "%s\n%s: $%,.2f\n\n",
         hourlyEmployee, "earned", hourlyEmployee.earnings() );
      System.out.printf( "%s\n%s: $%,.2f\n\n",
         commissionEmployee, "earned", commissionEmployee.earnings() );
      System.out.printf( "%s\n%s: $%,.2f\n\n", 
         basePlusCommissionEmployee, 
         "earned", basePlusCommissionEmployee.earnings() );
      
      // create four-element Employee array
      Employee[] employees = new Employee[ 5 ]; 
      Payable[] payments = new Payable[6];
      
      // initialize array with Employees
      employees[0] = salariedEmployee;
      employees[1] = hourlyEmployee;
      employees[2] = commissionEmployee; 
      employees[3] = basePlusCommissionEmployee;
      employees[4]=pieceWorker;
      
      Bill firstBill = new Bill(1000, 1234);
      
      payments[0] = salariedEmployee;
      payments[1] = hourlyEmployee;
      payments[2] = commissionEmployee; 
      payments[3] = basePlusCommissionEmployee;
      payments[4] = pieceWorker;
      payments[5] = firstBill;
      
      for(int i=0;i<payments.length;i++)
          System.out.println(payments[i]);
      
      System.out.println(salariedEmployee.toString());
      System.out.println(hourlyEmployee.toString());
      System.out.println(commissionEmployee.toString());
      System.out.println(basePlusCommissionEmployee.toString());
      System.out.println(pieceWorker.toString());
      System.out.println(firstBill.toString());
      
      
      Scanner input = new Scanner( System.in ); // to get current month
      int currentMonth;

      // get and validate current month
      do
      {
         System.out.print( "Enter the current month (1 - 12): " );
         currentMonth = input.nextInt();
         System.out.println();
      } while ( ( currentMonth < 1 ) || ( currentMonth > 12 ) );

      System.out.println( "Employees processed polymorphically:\n" );
      
      // generically process each element in array employees
      for ( Employee currentEmployee : employees ) 
      {
         System.out.println( currentEmployee ); // invokes toString

         // determine whether element is a BasePlusCommissionEmployee
         if ( currentEmployee instanceof BasePlusCommissionEmployee ) 
         {
            // downcast Employee reference to 
            // BasePlusCommissionEmployee reference
            BasePlusCommissionEmployee employee = 
               ( BasePlusCommissionEmployee ) currentEmployee;

            double oldBaseSalary = employee.getBaseSalary();
            employee.setBaseSalary( 1.10 * oldBaseSalary );
            System.out.printf( 
               "new base salary with 10%% increase is: $%,.2f\n",
               employee.getBaseSalary() );
         } // end if

         // if month of employee's birthday, add $100 to salary
         if ( currentMonth == currentEmployee.getBirthDate().getMonth() )
            System.out.printf(
               "earned $%,.2f %s\n\n", currentEmployee.earnings(), 
               "plus $100.00 birthday bonus" );
         else
            System.out.printf( 
               "earned $%,.2f\n\n", currentEmployee.earnings() );
      } // end for

      // get type name of each object in employees array
      for ( int j = 0; j < employees.length; j++ )
         System.out.printf( "Employee %d is a %s\n", j, 
            employees[ j ].getClass().getName() ); 
   } // end main
} // end class PayrollSystemTest

/**************************************************************************
 * (C) Copyright 1992-2010 by Deitel & Associates, Inc. and               *
 * Pearson Education, Inc. All Rights Reserved.                           *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/
