package Ex2;

// Exercise 10.10 Solution: PieceWorker
// PieceWorker class extends Employee.

public class PieceWorker extends Employee 
{
   private double wage; // wage per piece
   private int pieces; // pieces of merchandise produced in week

   // five-argument constructor
   public PieceWorker( String first, String last, String ssn, 
      double wagePerPiece, int piecesProduced )
   {
      super( first, last, ssn );
      setWage( wagePerPiece ); // validate and store wage per piece
      setPieces( piecesProduced ); // validate and store pieces produced
   } // end five-argument PieceWorker constructor

   // set wage
   public void setWage( double wagePerPiece )
   {
      wage = ( wagePerPiece < 0.0 ) ? 0.0 : wagePerPiece;
   } // end method setWage

   // return wage
   public double getWage()
   {
      return wage;
   } // end method getWage

   // set pieces produced
   public void setPieces( int piecesProduced )
   {
      pieces = ( piecesProduced < 0 ) ? 0 : piecesProduced;
   } // end method setPieces

   // return pieces produced
   public int getPieces()
   {
      return pieces;
   } // end method getPieces

   // calculate earnings; override abstract method earnings in Employee
   @Override
   public double earnings()
   {
      return getPieces() * getWage();
   } // end method earnings

   // return String representation of PieceWorker object
   @Override
   public String toString()
   {
      return String.format( "%s: %s\n%s: $%,.2f; %s: %d", 
         "piece worker", super.toString(), 
         "wage per piece", getWage(), "pieces produced", getPieces() );
   } // end method toString
} // end class PieceWorker


/**************************************************************************
 * (C) Copyright 1992-2010 by Deitel & Associates, Inc. and               *
 * Pearson Education, Inc. All Rights Reserved.                           *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/
